#include "Axis.h"
#include "ngl/Material.h"
#include "ngl/Camera.h"
#include <QDebug>

//----------------------------------------------------------------------------------------------------------------------
Axis::Axis(
           std::string _shaderName,
           ngl::Real _scale
          )
{
  m_shaderName=_shaderName;
  m_scale=_scale;
  qDebug()<<"Shader name is "<<_shaderName.c_str();

  ngl::VBOPrimitives *prim=ngl::VBOPrimitives::instance();
  prim->createVBOCylinder("nglAXISCylinder",0.02,2,60,60);
  prim->createVBOCone("nglAXISCone",0.05,0.2,30,30);
}

//----------------------------------------------------------------------------------------------------------------------
void Axis::draw(
                ngl::Real _xRot,
                ngl::Real _yRot
               )
{
  ngl::VBOPrimitives *prim=ngl::VBOPrimitives::instance();
  // grab an instance of the shader manager
  ngl::ShaderManager *shader=ngl::ShaderManager::instance();

  shader->useShader(m_shaderName);
  // Rotation based on the mouse position for our global
  // transform
   // set this in the TX stack
  // liberal use of { is encourage after each push
   ngl::Material m;
   m.setSpecularExponent(0.0);
   m.setSpecular(ngl::Colour());
   m.setEmisive(ngl::Colour());

  ngl::TransformStack txStack;
  ngl::Transformation tx;
  txStack.pushTransform();
  {

    // set the global rotation
    tx.setRotation(_xRot,_yRot,0.0);
    txStack.setCurrent(tx);

    txStack.pushTransform();
    {
   // liberal use of { is encourage after each push
    m.setDiffuse(ngl::Colour(1,0,0));
    m.use();
    txStack.getCurrentTransform().setScale(m_scale,m_scale,m_scale);
    txStack.getCurrentTransform().setPosition(ngl::Vector(m_scale,0,0));
    txStack.getCurrentTransform().setRotation(0,-90,0);
    txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
    prim->draw("nglAXISCylinder");

    txStack.getCurrentTransform().setPosition(ngl::Vector(m_scale,0,0));
    txStack.getCurrentTransform().setRotation(0,90,0);
    txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
    prim->draw("nglAXISCone");
    txStack.getCurrentTransform().setPosition(ngl::Vector(-m_scale,0,0));
    txStack.getCurrentTransform().setRotation(0,-90,0);
    txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
    prim->draw("nglAXISCone");
     // y axis
     m.setDiffuse(ngl::Colour(0,1,0));
     m.use();
     txStack.getCurrentTransform().setScale(m_scale,m_scale,m_scale);
     txStack.getCurrentTransform().setPosition(ngl::Vector(0,m_scale,0));
     txStack.getCurrentTransform().setRotation(90,0,90);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
     prim->draw("nglAXISCylinder");

     txStack.getCurrentTransform().setPosition(ngl::Vector(0,m_scale,0));
     txStack.getCurrentTransform().setRotation(-90,0,0);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
     prim->draw("nglAXISCone");
     txStack.getCurrentTransform().setPosition(ngl::Vector(0,-m_scale,0));
     txStack.getCurrentTransform().setRotation(90,0,0);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
     prim->draw("nglAXISCone");

     // z axis
     m.setDiffuse(ngl::Colour(0,0,1));
     m.use();
     txStack.getCurrentTransform().setScale(m_scale,m_scale,m_scale);
     txStack.getCurrentTransform().setPosition(ngl::Vector(0,0,-m_scale));
     txStack.getCurrentTransform().setRotation(0,0,90);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
     prim->draw("nglAXISCylinder");

     txStack.getCurrentTransform().setPosition(ngl::Vector(0,0,m_scale));
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
     prim->draw("nglAXISCone");
     txStack.getCurrentTransform().setPosition(ngl::Vector(0,0,-m_scale));
     txStack.getCurrentTransform().setRotation(180,0,0);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
     prim->draw("nglAXISCone");

  }
  txStack.popTransform();
}
txStack.popTransform();

  /*
      m.setDiffuse(ngl::Colour(0,1,0));
      m.use();
      txStack.getCurrentTransform().setScale(m_scale,m_scale,m_scale);
      txStack.getCurrentTransform().setPosition(ngl::Vector(m_scale,0,0));
      txStack.getCurrentTransform().setRotation(0,-90,0);
      txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
      prim->draw("nglAXISCylinder");

      txStack.getCurrentTransform().setPosition(ngl::Vector(m_scale,0,0));
      txStack.getCurrentTransform().setRotation(0,90,0);
      txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
      prim->draw("nglAXISCone");
      txStack.getCurrentTransform().setPosition(ngl::Vector(-m_scale,0,0));
      txStack.getCurrentTransform().setRotation(0,-90,0);
      txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
      prim->draw("nglAXISCone");


      m.setDiffuse(ngl::Colour(0,0,1));
      m.use();
      txStack.getCurrentTransform().setScale(m_scale,m_scale,m_scale);
      txStack.getCurrentTransform().setPosition(ngl::Vector(m_scale,0,0));
      txStack.getCurrentTransform().setRotation(0,-90,0);
      txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
      prim->draw("nglAXISCylinder");

      txStack.getCurrentTransform().setPosition(ngl::Vector(m_scale,0,0));
      txStack.getCurrentTransform().setRotation(0,90,0);
      txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
      prim->draw("nglAXISCone");
      txStack.getCurrentTransform().setPosition(ngl::Vector(-m_scale,0,0));
      txStack.getCurrentTransform().setRotation(0,-90,0);
      txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
      prim->draw("nglAXISCone");


*/

/*

   txStack.pushTransform();
   {
     m.setDiffuse(ngl::Colour(0,1,0));
     m.use();
     txStack.getCurrentTransform().setScale(m_scale,m_scale,m_scale);
     txStack.getCurrentTransform().setPosition(ngl::Vector(m_scale,0,0));
     txStack.getCurrentTransform().setRotation(0,-90,0);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
     // now draw the teapot
     prim->draw("nglAXISCylinder");

     txStack.getCurrentTransform().setPosition(ngl::Vector(-m_scale,0,0));
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");

     prim->draw("nglAXISCone");
     txStack.getCurrentTransform().setPosition(ngl::Vector(m_scale,0,0));
     txStack.getCurrentTransform().setRotation(0,90,0);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");

     prim->draw("nglAXISCone");

   } // and before a pop
   txStack.popTransform();

   */
/*
   txStack.pushTransform();
   {
     m.setDiffuse(ngl::Colour(0,0,1));
     m.use();
     txStack.getCurrentTransform().setScale(m_scale,m_scale,m_scale);
     txStack.getCurrentTransform().setPosition(ngl::Vector(0,-m_scale,0));
     txStack.getCurrentTransform().setRotation(-90,0,0);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");
     // now draw the teapot
     prim->draw("nglAXISCylinder");

     txStack.getCurrentTransform().setPosition(ngl::Vector(0,m_scale,0));
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");

     prim->draw("nglAXISCone");
     txStack.getCurrentTransform().setPosition(ngl::Vector(0,-m_scale,0));
     txStack.getCurrentTransform().setRotation(90,0,0);
     txStack.loadGlobalMatrixToShader("Blinn","ModelMatrix");

     prim->draw("nglAXISCone");

   } // and before a pop
   txStack.popTransform();
*/

}
//----------------------------------------------------------------------------------------------------------------------
